/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.client.internal.OpaqueClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("dojo.cookie");

(function() {

var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;

/**
 * Provides helper methods to save and retrieve data from the OpaqueRestService
 */
com.ibm.team.repository.web.client.internal.OpaqueClient = {
	
	// service URI
	SERVICE_URI: dojo.baseUrl + "../../service/com.ibm.team.opaque.service.IOpaqueRestService/",
	
	setValue: function(responseHandler, uri, content) {
		var bindArgs= {
			srh: responseHandler,
			url: this.SERVICE_URI + uri,
	        content: [ dojo.toJson(content) ],
			handleAs: "text",
			headers: {
				"content-type": "text/plain; charset=utf-8",
				"X-Jazz-CSRF-Prevent": dojo.cookie("JSESSIONID")
			},
			handle: function (response, ioArgs) {
				if (response instanceof Error) {
					// if the key does not yet exist, send this request as a "Post" instead of a "Put"
					if (ioArgs.xhr.status == 404) {
						dojo.xhrPost(this);
					}
					else {
						// send the error response to the response handler's error callback function
						eval("this.srh._contextObject." + this.srh._errorCallbackName + "(response)");
					}
				}
				else {
					// send the response to the response handler's callback function
					eval("this.srh._contextObject." + this.srh._callbackName + "(response)");
				}
			}
		}
		dojo.xhrPut(bindArgs);
	},
	
	getValue: function(responseHandler, uri) {
		var bindArgs= {
			srh: responseHandler,
			url: this.SERVICE_URI + uri,
			handleAs: "text",
			headers: {
				"content-type": "text/plain; charset=utf-8",
				"X-Jazz-CSRF-Prevent": dojo.cookie("JSESSIONID")
			},
			handle: function (response, ioArgs) {
				if (response instanceof Error) {
					// send the error response to the response handler's error callback function
					eval("this.srh._contextObject." + this.srh._errorCallbackName + "(response)");
				}
				else {
					// remove the "0=" from the beginning of the response, and unescape the URL-encoded string
					response = unescape(response.substring(2));
					response = dojo.fromJson(response);
					// send the response object to the response handler's callback function
					eval("this.srh._contextObject." + this.srh._callbackName + "(response)");
				}
			}
		}
		dojo.xhrGet(bindArgs);
	}
};

var OpaqueClient = com.ibm.team.repository.web.client.internal.OpaqueClient;

})();